package rabbit.awt;

// $Id: Status.java,v 1.2 2005/05/05 15:28:59 robo Exp $

import java.awt.*;

/** This class is a simple statusbar, that is a 
 *  Component that shows some text.
 */
public class Status extends Component {
    private static final long serialVersionUID = 20050430;

    /** @serial */
    private String status = "";

    /** The default constructor.
     */
    public Status () {    
    }

    /** Set the status to show.
     * @param status the new status string.
     */
    public void setStatus (String status) {
	this.status = status;
    }

    /** Get the prefered size of this statusbar.
     * @return the prefered size of this statusbar.
     */
    public Dimension getPreferredSize () {
	FontMetrics fm = getFontMetrics (getFont ());
	return new Dimension (0, fm.getHeight () + fm.getDescent ());
    }
    
    /** Paint this status on a given Graphics.
     * @param g the Graphics to draw on.
     */
    public void paint (Graphics g) {
	FontMetrics fm = getFontMetrics (getFont ());
	g.setColor (getBackground ());
	Dimension d = getSize ();
	g.fillRect (0,0, d.width, d.height);
	g.setColor (getForeground ());
	g.drawString (status, 0, fm.getHeight ());
    }
}
