package rabbit.filter;

// $Id: HTMLFilter.java,v 1.4 2005/08/02 20:50:21 robo Exp $

import rabbit.html.HTMLBlock;
import rabbit.http.HTTPHeader;
import rabbit.proxy.Connection;

/** This class describes the functions neccessary to filter a block of
 *  html. 
 */
public abstract class HTMLFilter implements HTMLFilterFactory {
    /** The Connection handling the request. */
    protected Connection con;
    /** The actual request made. */
    protected HTTPHeader request;
    /** The actual response. */
    protected HTTPHeader response;

    /** Create the factory.
     */
    public HTMLFilter () {
    }

    /** Create a new HTMLFilter for the given request, response pair.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public HTMLFilter (Connection con, HTTPHeader request, HTTPHeader response) {
	this.con = con;
	this.request = request;
	this.response = response;
    }

    /** Get a new HTMLFilter for the given request, response pair.
     * @param con the Connection handling the request.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public abstract HTMLFilter newFilter (Connection con, 
					  HTTPHeader request, 
					  HTTPHeader response);
    
    /** Filter a block of html.
     * @param block the part of the html page to filter.
     */
    public abstract void filterHTML (HTMLBlock block);
}
