package rabbit.filter;

// $Id: HTTPFilter.java,v 1.3 2005/08/02 20:50:21 robo Exp $

import java.net.Socket;
import rabbit.http.HTTPHeader;
import rabbit.proxy.Connection;
import rabbit.util.Logger;
import rabbit.util.SProperties;

/** A filter for http headers.
 */
public interface HTTPFilter {

    /** test if a socket/header combination is valid or 
     *  return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader 
     *         describing the error (like a 403).
     */
    HTTPHeader doHTTPInFiltering (Socket socket, 
				  HTTPHeader header, 
				  Connection con);

    /** test if a socket/header combination is valid or 
     *  return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader 
     *         describing the error (like a 403).
     */
    HTTPHeader doHTTPOutFiltering (Socket socket, 
				   HTTPHeader header, 
				   Connection con);

    /** Setup this filter.
     * @param logger the Logger to output errors/warnings on.
     * @param properties the SProperties to get the settings from.
     */
    void setup (Logger logger, SProperties properties);
}

