package rabbit.handler;

// $Id: HandlerFactory.java,v 1.4 2005/08/02 20:50:21 robo Exp $

import java.io.InputStream;
import rabbit.proxy.Connection;
import rabbit.http.HTTPHeader;
import rabbit.io.MultiOutputStream;
import rabbit.io.HTTPInputStream;
import rabbit.util.Logger;
import rabbit.util.SProperties;

/** The methods needed to create a new Handler.
 */ 
public interface HandlerFactory {
    
    /** Get a new Handler for the given request made.
     * @param connection the Connection handling the request.
     * @param header the request.
     * @param webheader the response.
     * @param contentStream the data to read.
     * @param out the client (and possibly the cache).
     * @param maycache if the handler may cache the response.
     * @param mayfilter if the handler may filter the response.
     * @param size the Size of the data beeing handled (-1 = unknown length).
     */
    public Handler getNewInstance (Connection connection,
				   HTTPHeader header, 
				   HTTPHeader webheader, 
				   HTTPInputStream contentStream, 
				   MultiOutputStream out, 
				   boolean maycache, 
				   boolean mayfilter, 
				   long size);
    
    /** setup the handler factory. 
     */
    public void setup (Logger logger, SProperties properties);
}
