package rabbit.meta;

// $Id: AccessGetter.java,v 1.9 2005/08/02 00:06:38 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.filter.*;
import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;
import rabbit.util.*;

/** A metapage that allows setting of the valid ip addreses.
 */
public class AccessGetter implements MetaHandler {

    /** default constructor */
    public AccessGetter () {
    }
    
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	saveData (header, con);
	sendPage (output, con);
    }

    private void saveData (HTTPHeader header, Connection con) {
	try {
	    String content = header.getContent ();
	    if (content == null) {
		byte[] contentArr = header.getContentArr ();
		if (contentArr != null)
		    content = new String (contentArr);
	    }
	    if (content == null)
		return;
	    Properties prop2 = con.splitArgs (content);
	    String cls = prop2.getProperty ("class");
	    if (cls == null || cls.equals (""))
		return;
	    String data = prop2.getProperty ("access");
	    if (data == null)
		return;
	    for (IPAccessFilter ipf : con.getProxy ().getAccessFilters ()) {
		if (ipf.getClass ().getName ().equals (cls)) {
		    Logger logger = con.getProxy ();
		    ipf.loadAccess (logger, new StringReader (data));
		    ipf.saveAccess (logger, new StringReader (data));
		    break;
		}
	    }
	} catch (IOException e) {
	    con.getProxy ().logError (Logger.WARN, 
				      "When trying to handle access data: " + e);
	}
    }

    public void sendPage (MultiOutputStream output, Connection con) {
	try {      
	    HTTPHeader response = con.getResponseHandler ().getHeader ();
	    output.writeHTTPHeader (response);
	    output.write (HTMLPage.getPageHeader (con, "IP Access Configuration").getBytes ());
	
	    for (IPAccessFilter ipf : con.getProxy ().getAccessFilters ()) {
		output.write (("<form method=post action=AccessGetter>" +
			       "<input type=\"hidden\" name=\"class\" value=\"" + 
			       ipf.getClass ().getName () + "\">" +
			       "<TEXTAREA name=\"access\" ROWS=10 COLS=55>").getBytes ());
		List<IPAccess> iplist = ipf.getIPList ();
		for (int i = 0, j = iplist.size (); i < j; i++) {
		    IPAccess ipa = iplist.get (i);
		    output.write ((ipa.toString () + "\n").getBytes ());
		} 
		output.write ("</textarea><br><input type=\"submit\" value=\"Save\"></form>".getBytes ());
	    } 
	    output.write ("</body></html>".getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write " + getClass().getName());
	}	
    }
}
