package rabbit.meta;

// $Id: ConfigGetter.java,v 1.6 2005/08/02 00:06:38 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;
import rabbit.util.*;

/** A MetaPage that sends the config of the proxy.
 */
public class ConfigGetter implements MetaHandler {
    /** default constructor */
    public ConfigGetter () {
    }
    
    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	HTTPHeader response = con.getResponseHandler ().getHeader ();
	Config config = new Config ();
	try {
	    config = new Config (new StringReader (header.getContent ()));
	} catch (IOException e) {
	    e.printStackTrace ();
	    con.getProxy ().logError ("Couldnt read config");
	}
	
	response.setHeader ("Content-type", "text/plain");
	StringBuilder res = new StringBuilder ();
	res.append (config.toString ());
	try {      
	    output.writeHTTPHeader (response);
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write " + getClass ().getName ());
	}	
    }
}
