package rabbit.meta;

// $Id: LogRotator.java,v 1.4 2005/08/01 12:43:45 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;

/** the Metapage that rotates the logs
 */
public class LogRotator implements MetaHandler {
    /** default constructor */
    public LogRotator () {
    }

    /** handler of a MetaPage, that is a special page the proxy supports. 
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {      
	    con.getProxy ().rotateLogs ();
	    output.writeHTTPHeader (con.getResponseHandler ().getHeader ());
	    StringBuilder res = new StringBuilder (HTMLPage.getPageHeader (con, "Logs rotated"));
	    res.append ("\n</body></html>");
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write log rotate status");
	}
    }
}
