package rabbit.meta;

// $Id: ProxyConfig.java,v 1.6 2005/08/01 12:43:45 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.filter.*;
import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;
import rabbit.util.*;

/** A MetaPage that allows setting the cofig of the proxy.
 */
public class ProxyConfig extends SimpleHandler {
    private static final String mark = "config=";

    /** default constructor */
    public ProxyConfig () {
    }

    public String getMark () {
	return mark;
    }
    
    public void handleData (Connection con, String data) {
	try {
	    Config config = new Config (new StringReader (data));
	    con.getProxy ().reConfigure (config);
	} catch (IOException e) {
	    // Ignore..
	}
    }

    public void sendPage (MultiOutputStream output, Connection con) {
	HTTPHeader response = con.getResponseHandler ().getHeader ();
	StringBuilder res = new StringBuilder ();	
	res.append (HTMLPage.getPageHeader (con, "Proxy Configuration"));
	
	res.append ("<form method=post action=ProxyConfig><TEXTAREA name=config ROWS=20 COLS=55>");
	res.append (con.getProxy ().getConfig ().toString ());
	res.append ("</textarea><br><input type=\"submit\" value=\"Save\"></form>");
	res.append ("</body></html>");

	try {      
	    output.writeHTTPHeader (response);
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write " + getClass().getName());
	}	
    }
}
