package rabbit.meta;

// $Id: StackTrace.java,v 1.2 2005/08/01 12:43:45 robo Exp $

import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;
import rabbit.http.*;
import rabbit.html.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;

/** Get all the stack traces
 */
public class StackTrace implements MetaHandler {
    /** default constructor */
    public StackTrace () {
    }

    /** handler of a MetaPage.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the request.
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving this metapage.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {	
	try {
	    output.writeHTTPHeader (con.getResponseHandler ().getHeader ());
	    output.write (HTMLPage.getPageHeader (con, "CacheStatus").getBytes ());
	    output.write ("<xmp>".getBytes ());
	    Map<Thread, StackTraceElement[]> m = Thread.getAllStackTraces ();
	    List<Thread> ls = new ArrayList<Thread> (m.keySet ());
	    Collections.sort (ls, new Comparator<Thread> () {
		public int compare (Thread t1, Thread t2) {
		    return t1.getName ().compareTo (t2.getName ());
		}
	    });
	    for (Thread t : ls) {
		output.write (t.toString ().getBytes ());
		output.write ("\n".getBytes ());
		for (StackTraceElement se : m.get (t))
		    output.write (("\t" + se + "\n").getBytes ());
		output.write ("\n".getBytes ());
	    }
	    output.write ("</xmp>".getBytes ());
	    output.write ("</body></html>".getBytes());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write stack traces");
	}
    }
}
