package rabbit.meta;

// $Id: UserGetter.java,v 1.8 2005/08/01 12:43:45 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.filter.*;
import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;
import rabbit.util.*;

/** A metapage that allows configuration of valid users.
 *
 *  TODO: rework the ugly handling of HTTPBaseFilter.
 */
public class UserGetter extends SimpleHandler {
    private static final String mark = "users=";

    /** default constructor */
    public UserGetter () {
    }
    
    public String getMark () {
	return mark;
    }

    public void handleData (Connection con, String data) {
	try {
	    for (HTTPFilter hf : con.getProxy ().getHTTPInFilters ()) {
		if (hf.getClass () == HTTPBaseFilter.class) {
		    HTTPBaseFilter hbf = (HTTPBaseFilter)hf;
		    hbf.setUsers (hbf.loadUsers (new StringReader (data)));
		    hbf.saveUsers (new StringReader (data));
		}
	    }
	} catch (IOException e) {
	    // Ignore..
	}
    }

    public void sendPage  (MultiOutputStream output, Connection con) {
	HTTPHeader response = con.getResponseHandler ().getHeader ();
	StringBuilder res = new StringBuilder ();
	res.append (HTMLPage.getPageHeader (con, "User Configuration"));
	
	res.append ("<form method=post action=UserGetter>" + 
		    "<TEXTAREA name=users ROWS=10 COLS=55>");

	for (HTTPFilter hf : con.getProxy ().getHTTPInFilters ()) {
	    if (hf.getClass () == HTTPBaseFilter.class) {
		HTTPBaseFilter hbf = (HTTPBaseFilter)hf;
		Map<String, String> users = hbf.getUsers ();
		for (Map.Entry<String, String> me : users.entrySet ()) {
		    String username = me.getKey ();
		    String pwd = me.getValue ();
		    res.append (username);
		    res.append (':');
		    res.append (pwd);
		    res.append ('\n');
		}
	    }
	}
	res.append ("</textarea><br>" + 
		    "<input type=\"submit\" value=\"Save\"></form>");
	res.append ("</body></html>");

	try {      
	    output.writeHTTPHeader (response);
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Couldnt write ConfigGetter");
	}	
    }
}
