package rabbit.proxy;

// $Id: CacheStream.java,v 1.3 2005/08/01 12:43:45 robo Exp $

import java.io.*;

import rabbit.cache.NCache;
import rabbit.cache.NCacheEntry;
import rabbit.util.Counter;

/** This class reads data from a cachefile.
 */
public class CacheStream extends FileInputStream {
    private Counter counter;
    /** Create a new CacheStream from the given NCacheEntry
     * @param entry the NCacheEntry to read data from.
     * @throws FileNotFoundException if the cachefile is not found.
     */
    public CacheStream (NCache cache, NCacheEntry entry, Counter counter) 
	throws FileNotFoundException {
	super (cache.getEntryName (entry));
	this.counter = counter;
	counter.inc ("CacheStream opened");
    }

    public void close () throws IOException {
	counter.inc ("CacheStream closed");
	super.close ();
    }
}
