package rabbit.proxy;

// $Id: DNSHandler.java,v 1.3 2005/08/02 20:50:21 robo Exp $

import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;

/** A DNS handler. 
 */
public interface DNSHandler {
    /** Do any neccessary setup. 
     * @param proxy the Proxy to handle dns requests for.
     */
    public void setup (Proxy proxy);
    
    /** Look up an internet address. 
     * @param url the url to get the host from
     */
    public InetAddress getInetAddress (URL url) 
	throws UnknownHostException;    

    /** Look up an internet address. 
     * @param host the name of the host to lookup
     */
    public InetAddress getInetAddress (String host) 
	throws UnknownHostException;
}
