package rabbit.util;

// $Id: Logger.java,v 1.1 2005/08/02 20:50:21 robo Exp $

/** A logger interface. 
 */
public interface Logger {
    /** Show all messages in the log. */
    final int DEBUG = 0;
    /** Show all normal messages and higher. */
    final int ALL   = 5;
    /** Show information messages and higher. */
    final int INFO  = 10;
    /** Show warnings and higer. */
    final int WARN  = 15;
    /** Show important messages and above. */
    final int MSG   = 20;
    /** Show error messages and higer. */
    final int ERROR = 25;  
    /** Show only fatal messages. */
    final int FATAL = 30;

    /** Log an error.
     *  Same as <code>logError (ERROR, error);</code>
     */
    void logError (String error);

    /** Log an error of given type and with given message.
     * @param type the error level.
     * @param error the error message.
     */
    void logError (int type, String error);   
}
